#!/usr/bin/env python
#  tutorial http://www.tutorialspoint.com/python/os_popen.htm
#  liste des fonctions disponibles https://docs.python.org/release/3.6.0rc2/py-modindex.html
#
LINE_OUT = ""
global NEW_COOR
NEW_COOR = [0.0,0.0,0.0]
global OLD_COOR
OLD_COOR = [0.0,0.0,0.0]
global IJK
IJK = [0.0,0.0,0.0]
global COOR_MINI
COOR_MINI=[10000.0,10000.0,10000.0]
global COOR_MAXI
COOR_MAXI=[-10000.0,-10000.0,-10000.0]
global FEEDRAT
FEEDRAT = 0.0
global SPINDLE
SPINDLE = 0.0
global ORDRE_G # G0 ORDRE_G = 0, G1 ordre = 1  , etc...
ORDRE_G = -1
global ORDRE_M
ORDRE_M = -1
global LETTRE_ADRESSE # X = 0, Y = 1, Z = 2  , I = 3 , J = 4, K = 5, F = 6 
LETTRE_ADRESSE = -1
global DISTANCE_TRAVAIL
DISTANCE_TRAVAIL = 0
global DISTANCE_RAPID
DISTANCE_RAPID = 0
global VITESSE_RAPIDE
VITESSE_RAPIDE=800
global TEMPS_TRAVAIL
TEMPS_TRAVAIL=0
global TEMPS_RAPIDE
TEMPS_RAPIDE=0
global DISTANCE_TEMPO_TRAVAIL
DISTANCE_TEMPO_TRAVAIL = 0
global DISTANCE_TEMPO_RAPIDE
DISTANCE_TEMPO_RAPIDE = 0
import string
#---------------

from tkinter.commondialog import Dialog

__all__ = ["showinfo", "showwarning", "showerror",
           "askquestion", "askokcancel", "askyesno",
           "askyesnocancel", "askretrycancel"]

#
# constants

# icons
ERROR = "error"
INFO = "info"
QUESTION = "question"
WARNING = "warning"

# types
ABORTRETRYIGNORE = "abortretryignore"
OK = "ok"
OKCANCEL = "okcancel"
RETRYCANCEL = "retrycancel"
YESNO = "yesno"
YESNOCANCEL = "yesnocancel"

# replies
ABORT = "abort"
RETRY = "retry"
IGNORE = "ignore"
OK = "ok"
CANCEL = "cancel"
YES = "yes"
NO = "no"


#
# message dialog class

class Message(Dialog):
    "A message box"

    command  = "tk_messageBox"


#
# convenience stuff

# Rename _icon and _type options to allow overriding them in options
def _show(title=None, message=None, _icon=None, _type=None, **options):
    if _icon and "icon" not in options:    options["icon"] = _icon
    if _type and "type" not in options:    options["type"] = _type
    if title:   options["title"] = title
    if message: options["message"] = message
    res = Message(**options).show()
    # In some Tcl installations, yes/no is converted into a boolean.
    if isinstance(res, bool):
        if res:
            return YES
        return NO
    # In others we get a Tcl_Obj.
    return str(res)


def showinfo(title=None, message=None, **options):
    "Show an info message"
    return _show(title, message, INFO, OK, **options)


def showwarning(title=None, message=None, **options):
    "Show a warning message"
    return _show(title, message, WARNING, OK, **options)


def showerror(title=None, message=None, **options):
    "Show an error message"
    return _show(title, message, ERROR, OK, **options)


def askquestion(title=None, message=None, **options):
    "Ask a question"
    return _show(title, message, QUESTION, YESNO, **options)


def askokcancel(title=None, message=None, **options):
    "Ask if operation should proceed; return true if the answer is ok"
    s = _show(title, message, QUESTION, OKCANCEL, **options)
    return s == OK


def askyesno(title=None, message=None, **options):
    "Ask a question; return true if the answer is yes"
    s = _show(title, message, QUESTION, YESNO, **options)
    return s == YES


def askyesnocancel(title=None, message=None, **options):
    "Ask a question; return true if the answer is yes, None if cancelled."
    s = _show(title, message, QUESTION, YESNOCANCEL, **options)
    # s might be a Tcl index object, so convert it to a string
    s = str(s)
    if s == CANCEL:
        return None
    return s == YES


def askretrycancel(title=None, message=None, **options):
    "Ask if operation should be retried; return true if the answer is yes"
    s = _show(title, message, WARNING, RETRYCANCEL, **options)
    return s == RETRY

#-------------------
	
def decale_1_caractere (sub_ligne):
	ligne_temp=' '
	for compteur in range (1 ,len (sub_ligne)):
		ligne_temp = ligne_temp + sub_ligne[compteur]
	return (ligne_temp)

def swap_new_old():
	global NEW_COOR
	global OLD_COOR
	OLD_COOR = [NEW_COOR[0],NEW_COOR[1],NEW_COOR[2]]
def distance(point_start,point_end):

	d1 = sqrt((point_end[0] - point_start[0]) * (point_end[0] - point_start[0]) + (point_end[1] - point_start[1]) * (point_end[1] - point_start[1]) + (point_end[2] - point_start[2]) * (point_end[2] - point_start[2]))
	return (d1)
 
def analyse_sub_line (sub_ligne):
	global NEW_COOR
	global IJK
	global LETTRE_ADRESSE
	global FEEDRAT
	global SPINDLE
	global COOR_MINI
	global COOR_MAXI
	global ORDRE_G
	
	
	LETTRE_ADRESSE= -1

	
	if (sub_ligne[0].upper() == 'X'):
		LETTRE_ADRESSE= 0
	if (sub_ligne[0].upper() == 'Y'):
		LETTRE_ADRESSE= 1
	if (sub_ligne[0].upper() == 'Z'):
		LETTRE_ADRESSE= 2
	if (sub_ligne[0].upper() == 'I'):
		LETTRE_ADRESSE= 3
	if (sub_ligne[0].upper() == 'J'):
		LETTRE_ADRESSE= 4
	if (sub_ligne[0].upper() == 'K'):
		LETTRE_ADRESSE= 5
	if (sub_ligne[0].upper() == 'F'):
		LETTRE_ADRESSE= 6
	if (sub_ligne[0].upper() == 'S'):
		LETTRE_ADRESSE= 7
	if (sub_ligne[0].upper() == 'G'):
		ligne_temp = decale_1_caractere (sub_ligne)
		ORDRE_G = int(ligne_temp)
	if (sub_ligne[0].upper() == 'M'):
		ligne_temp = decale_1_caractere (sub_ligne)
		ORDRE_M = int(ligne_temp)
	if ( LETTRE_ADRESSE == -1 ):
		return()
	
	ligne_temp = decale_1_caractere (sub_ligne)

	if ( LETTRE_ADRESSE == 0 or LETTRE_ADRESSE == 1 or LETTRE_ADRESSE ==  2):
		NEW_COOR[LETTRE_ADRESSE] = float(ligne_temp)
		if (NEW_COOR[LETTRE_ADRESSE] < COOR_MINI[LETTRE_ADRESSE]):
			COOR_MINI[LETTRE_ADRESSE] = NEW_COOR[LETTRE_ADRESSE]
		if (NEW_COOR[LETTRE_ADRESSE] > COOR_MAXI[LETTRE_ADRESSE]):
			COOR_MAXI[LETTRE_ADRESSE] = NEW_COOR[LETTRE_ADRESSE]
	if ( LETTRE_ADRESSE == 3 or LETTRE_ADRESSE == 4 or LETTRE_ADRESSE ==  5):
		IJK[LETTRE_ADRESSE-3] = float(ligne_temp)
	if ( LETTRE_ADRESSE == 6):
		FEEDRAT = float(ligne_temp)
	if ( LETTRE_ADRESSE == 7):
		SPINDLE = float(ligne_temp)
		
def analyse_ligne (ligne):
		global LINE_OUT
		global ORDRE_G
		global DISTANCE_RAPID
		global DISTANCE_TRAVAIL
		global TEMPS_TRAVAIL
		global DISTANCE_TEMPO_TRAVAIL
		global DISTANCE_TEMPO_RAPIDE
		
		ORDRE_G = -1
		
		index = ligne.find(';')
		if (index == 0):
			return
		index = ligne.find('(')
		if (index == 0):
		#  on affiche les données temporaires pour cette operation
			if ( DISTANCE_TRAVAIL > DISTANCE_TEMPO_TRAVAIL):
				distance_travail_operation =  DISTANCE_TRAVAIL - DISTANCE_TEMPO_TRAVAIL
				DISTANCE_TEMPO_TRAVAIL = DISTANCE_TRAVAIL
				LINE_OUT = LINE_OUT + "Distance en vitesse travaille pour cette operation = " + "{:10.2f}".format(distance_travail_operation) + " mm"  + chr(10)
				distance_rapide_operation =  DISTANCE_RAPID - DISTANCE_TEMPO_RAPIDE
				DISTANCE_TEMPO_RAPIDE = DISTANCE_RAPID
				LINE_OUT = LINE_OUT + "Distance en vitesse rapide pour cette operation    = " + "{:10.2f}".format(distance_rapide_operation) + " mm"  + chr(10)
#LINE_OUT = LINE_OUT + "Distance en vitesse travaille     = " + "{:10.2f}".format(DISTANCE_TRAVAIL) + " mm" + chr(10)
#TEMPS_RAPIDE = DISTANCE_RAPID/VITESSE_RAPIDE
#LINE_OUT = LINE_OUT + "Temps total en vitesse rapide     = " + "{:10.2f}".format(TEMPS_RAPIDE) + " minutes" + chr(10)
#LINE_OUT = LINE_OUT + "Temps total en vitesse travaille  = " + "{:10.2f}".format(TEMPS_TRAVAIL) + " minutes" + chr(10)

			LINE_OUT = LINE_OUT + ligne + chr(10)
			return
		ligne_parse = ligne.split(" ")	

		for sub_ligne in ligne_parse:
			analyse_sub_line(sub_ligne)
		if ( ORDRE_G == 0):
			DISTANCE_RAPID=DISTANCE_RAPID+distance(OLD_COOR,NEW_COOR)
			swap_new_old()
		if ( ORDRE_G == 1):
			DISTANCE_TRAVAIL=DISTANCE_TRAVAIL+distance(OLD_COOR,NEW_COOR)
			TEMPS_TRAVAIL = TEMPS_TRAVAIL + distance(OLD_COOR,NEW_COOR) / FEEDRAT
			swap_new_old()
	
from tkinter import filedialog
from tkinter import *
from math import *
import os, os.path
repcour = os.getcwd()

root = Tk ()
root.filename = filedialog.askopenfilename (initialdir=repcour, title="Selectionnez votre fichier gcode", filetypes=(("jpeg files", "*.gcode"), ("all files", "*.*")))
print (" ")
print (root.filename)

#   lecture du fichier
#
fo = open(root.filename,'r')
#
str = fo.read();
# Close opend file
fo.close()

compteur_ligne = 0
longueur_file = len(str) - 1
continue_loop = True
compteur_car = 0
ligne = ""
#
#   on analyse chaque ligne
#
while continue_loop == True:
#   ord() donne la valeur ascii du caractere, chr(97) donne le caractere dont la valeur ascii est 97
	valeur_ascii = ord(str[compteur_car])
	if ( valeur_ascii == 10 or compteur_car > longueur_file):
		compteur_ligne = compteur_ligne + 1
		analyse_ligne (ligne)
		ligne=""
		compteur_car = compteur_car+1
		if ( compteur_car > longueur_file ):
			continue_loop = False
	else:
		ligne = ligne + str[compteur_car]
		compteur_car = compteur_car+1
		if ( compteur_car > longueur_file ):
			analyse_ligne (ligne)
			continue_loop = False

#  on affiche les donnees temporaires de cette operation

if ( DISTANCE_TRAVAIL > DISTANCE_TEMPO_TRAVAIL):
	distance_travail_operation =  DISTANCE_TRAVAIL - DISTANCE_TEMPO_TRAVAIL
	DISTANCE_TEMPO_TRAVAIL = DISTANCE_TRAVAIL
	LINE_OUT = LINE_OUT + "Distance en vitesse travaille pour cette operation = " + "{:10.2f}".format(distance_travail_operation) + " mm"  + chr(10)
	distance_rapide_operation =  DISTANCE_RAPID - DISTANCE_TEMPO_RAPIDE
	DISTANCE_TEMPO_RAPIDE = DISTANCE_RAPID
	LINE_OUT = LINE_OUT + "Distance en vitesse rapide pour cette operation    = " + "{:10.2f}".format(distance_rapide_operation) + " mm"  + chr(10)
				
LINE_OUT = LINE_OUT + chr(10) + chr(10) + chr(10)		
# on affiche la synthese globale

LINE_OUT = LINE_OUT + "Synthese globale" + chr(10)	 + chr(10)			
LINE_OUT = LINE_OUT + "Distance en vitesse rapide        = " + "{:10.2f}".format(DISTANCE_RAPID) + " mm"  + chr(10)
LINE_OUT = LINE_OUT + "Distance en vitesse travaille     = " + "{:10.2f}".format(DISTANCE_TRAVAIL) + " mm" + chr(10)
TEMPS_RAPIDE = DISTANCE_RAPID/VITESSE_RAPIDE
LINE_OUT = LINE_OUT + "Temps total en vitesse rapide     = " + "{:10.2f}".format(TEMPS_RAPIDE) + " minutes" + chr(10)
LINE_OUT = LINE_OUT + "Temps total en vitesse travaille  = " + "{:10.2f}".format(TEMPS_TRAVAIL) + " minutes" + chr(10)
LINE_OUT = LINE_OUT + "Derniere vitesse d'avance trouvée = " + "{:8.0f}".format(FEEDRAT) + " mm/minute" + chr(10)
LINE_OUT = LINE_OUT + "Derniere vitesse de broche trouvée= " + "{:8.0f}".format(SPINDLE) + " tr/minute" + chr(10)
LINE_OUT = LINE_OUT + "X minimum                         = " + "{:10.2f}".format(COOR_MINI[0])  + chr(10)
LINE_OUT = LINE_OUT + "Y minimum                         = " + "{:10.2f}".format(COOR_MINI[1])  + chr(10)
LINE_OUT = LINE_OUT + "Z minimum                         = " + "{:10.2f}".format(COOR_MINI[2])  + chr(10)
LINE_OUT = LINE_OUT + "X maximum                         = " + "{:10.2f}".format(COOR_MAXI[0])  + chr(10)
LINE_OUT = LINE_OUT + "Y maximum                         = " + "{:10.2f}".format(COOR_MAXI[1])  + chr(10)
LINE_OUT = LINE_OUT + "Z maximum                         = " + "{:10.2f}".format(COOR_MAXI[2])  + chr(10)
print (LINE_OUT)

if __name__ == "__main__":

    print("info", showinfo("Spam", "Egg Information"))
    print("warning", showwarning("Spam", "Egg Warning"))
    print("error", showerror("Spam", "Egg Alert"))
    print("question", askquestion("Spam", "Question?"))
    print("proceed", askokcancel("Spam", "Proceed?"))
    print("yes/no", askyesno("Spam", "Got it?"))
    print("yes/no/cancel", askyesnocancel("Spam", "Want it?"))
    print("try again", askretrycancel("Spam", "Try again?"))
#
